jp ___STRINGSKIP
;----------------------------------------;
; Inputs:                                ;
;   A   -   Number to convert            ;
; Outputs:                               ;
;   HL  -   Points to the data location  ;
;   A   -   Is preserved                 ;
;----------------------------------------;
_AToString:
    ld (_AToASCII_preserve), a
    ld c, a
    ld h, 0
    ld l, a
    
    ; Clean up
    ld a, 0
    ld (_AToASCII_dump), a
    ld (_AToASCII_dump+1), a
    ld (_AToASCII_dump+2), a
    ld (_AToASCII_dump+3), a
    ld (_AToASCII_i), a
    ld (_AToASCII_switch), a
    
    ld a, 0
    ld (_AToASCII_switch), a
    
    ; Get hundreds and tens place
    call _AToASCII100
    call _AToASCII10 
   
    ; Get 1s place
    ld a, (_AToASCII_i)
    ld de, _AToASCII_dump
    ld c, a
    add a, e
    ld e, a
    ld a, c
    inc a
    ld (_AToASCII_i), a
    
    ld a, b
    add a, 48
    ld (de), a
    
    ld hl, _AToASCII_dump
    ld a, (_AToASCII_preserve)
    ret
    
_AToASCII100:
    ld a, 100
    rst 28h
    dw _DivHLByA            
    ld b, a
    
    ld a, (_AToASCII_i)
    ld de, _AToASCII_dump
    ld c, a
    add a, e
    ld e, a
    
    ld a, l
    cp 0
    jp nz, _AToASCII100_noskip
    ld a, (_AToASCII_switch)
    cp 0
    jp nz, _AToASCII100_noskip
    jp _AToASCII100_skip
    
_AToASCII100_noskip:
    ld a, c
    inc a
    ld (_AToASCII_i), a
    ld (_AToASCII_switch), a
    
_AToASCII100_skip:
    
    ld a, l
    add a, 48
    ld (de), a
    ld a, b
    ld h, 0
    ld l, b
    
    
    ret
    
_AToASCII10:
    ld a, 10
    rst 28h
    dw _DivHLByA
    ld b, a
    
    ld a, (_AToASCII_i)
    ld de, _AToASCII_dump
    ld c, a
    add a, e
    ld e, a
    
    ld a, l
    cp 0
    jp nz, _AToASCII10_noskip
    ld a, (_AToASCII_switch)
    cp 0
    jp nz, _AToASCII10_noskip
    jp _AToASCII10_skip
    
_AToASCII10_noskip:
    ld a, c
    inc a
    ld (_AToASCII_i), a
    ld (_AToASCII_switch), a
    
_AToASCII10_skip:
    
    ld a, l
    add a, 48
    ld (de), a
    
    ret
    
_AToASCII_dump:
    db 0,0,0,0
    
_AToASCII_i:
    db 0
    
_AToASCII_switch:
    db 0
    
_AToASCII_preserve:
    db 0
    
___STRINGSKIP: